; ASCKBD.ASM
; ASCII KEYBOARD INPUT ROUTINE
;
KEND	EQU  #0308	; STORE KEYPRESS
LASTK	EQU  23560	; KEY PRESSED
KBDKEY	EQU  253	; ASCII KBD DATA
KBDSHF	EQU  249	; ASCII KBD STATUS
;

KBDGET	BIT  5,(IY+1)	; KEY ALREADY PRESSED?
	RET  NZ		; RETURN WITH NZ=KEY
	HALT		; SYNC WITH KEYBOARD
	IN   A,(KBDKEY)	; READ KEYPRESS
	CP   255	; NO KEY PRESSED?
	RET  Z		; RETURN WITH Z=NO KEY
	CALL KBDCONV	; CHECK KEYPRESS
	JP   KEND	; STORE KEYPRESS

KBDCONV	LD   C,A	; C=KEYPRESS
	IN   A,(KBDSHF)	; GET KBD STATUS
	LD   B,A	; B=STATUS, B1=CTRL B0=SHIFT
	LD   A,C	; A=C=KEYPRESS
	CP   127
	JR   NC,KBDPAD	; KEYPAD AND DELETE
	CP   32
	RET  NC		; NOT CONTROLS
	BIT  1,B	; IS CTRL PRESSED?
	JR   NZ,KBDCTRL	; CTRL PRESSED
	LD   HL,KBDTAB-8
	LD   B,0	; BC=KEYPRESS
	ADD  HL,BC	; INDEX INTO TABLE
	LD   A,(HL)	; CONVERT SPECIAL KEY
	RET
KBDTAB	DEFB 14,15,6,9	; BS,TAB,LF,RGT
	DEFB 30,13	; HOME,RET
KBDCTRL	AND  A		; IS IT CTRL-@?
	JR   NZ,KBDGRAF	; SQUEEZE INTO TABLE
	LD   A,127	; CTRL-@ RETURNS (C)
	RET
	DEFB 0,08,00,00	; XXX,LFT,XXX,XXX
	DEFB 7,10,11,27	; CLR,DWN,UP,ESC
KBDGRAF	ADD  A,143	; CONVERT TO GRAPHICS CHAR
	CP   143+27
	RET  C		; CTRL-A TO CTRL-Z
	CP   143+28
	ADD  171-143	; CONVERT [  \  ]  ^  _
	RET		; TO      <= <= >= <> LINE
KBDPAD	JR   Z,KBDDEL	; DELETE
	AND  143	; CONVERT TO BLOCK SHAR
	BIT  0,C	; IS SHIFT PRESSED?
	RET  Z		; NOT PRESSED, RETURN IT
	XOR  15		; INVERT BLOCK CHARACTER
	RET
KBDDEL	LD   A,12	; DELETE
	RET		; 127 -> DELETE
